# -*- coding: utf-8 -*-

from tkinter import *
from math import sqrt


class MyApplication:
    GENERAL_TRIANGLE = "Obecný trojúhelník"
    RIGHT_TRIANGLE = "Pravoúhly trojúhelník"
    EQUILATERAL_TRIANGLE = "Rovnostraný trojúhelník"

    def __init__(self, root):
        self._root = root
        self._root.title("Triangle")
        
        # create Frame with Pack container
        self._top = Frame(self._root)
        self._top.pack(fill = BOTH)
        
        # TODO top
        
        # inputs area
        self._left_frame = Frame(
            self._top, 
            relief = GROOVE, # FLAT, RAISED, SUNKEN, GROOVE, RIDGE
            borderwidth = 2, 
        )
        self._left_frame.pack(
            fill = Y, side=LEFT, 
            padx = 4, pady = 4, ipady = 4
        )
        
        # labels for inputs. TODO b and c
        self._label_a = Label(self._left_frame, text = "Strana a =")
        self._label_b = Label(self._left_frame, text = "Strana b =")
        
        # inputs
        self._input_a = Entry(self._left_frame, width = 14)
        
        # assign labels and inputs
        self._label_a.pack(fill=X, padx = 8, pady = 1)
        self._input_a.pack(padx = 8, pady = 1)
        self._label_b.pack(fill=X, padx = 8, pady = 1)
        
        # button
        self._button = Button(
            self._left_frame, 
            text = "Vymazat", 
            command = self.reset # command without brackets
            # command = lambda: self.reset() # alternative
        )
        self._button.pack(padx = 4, pady = 4)
        
        self.reset()
        
        # TODO area with computed results
        
        
    def reset(self):
        self._input_a.delete(0, END)
        self._input_a.insert(0, "0")
        self._input_a.focus_force()
        
    
    def solve(self):
        try:
            a = float(self._input_a.get())
            b = float(self._input_b.get())
            c = float(self._input_c.get())
            
            text = MyApplication.GENERAL_TRIANGLE
            if self.is_triangle(a, b, c):
                if self.is_right_triangle(a, b, c):
                    text = MyApplication.RIGHT_TRIANGLE
                if self.is_equilateral_triangle(a, b, c):
                    text = MyApplication.EQUILATERAL_TRIANGLE
                
                # TODO output of results
            else:
                # TODO show error information, it is not a triangle
                pass
                
        except ValueError:
            # TODO show error message - wrong values
            pass
        
        
    def compute_circumference(self, a, b, c):
        return a + b + c
    
    
    def compute_area(self, a, b, c):
        s = self.compute_circumference(a, b, c)
        return sqrt(s * (s - a) * (s - b) * (s - c))
        
        
    def is_triangle(self, a, b, c):
        # TODO
        return True
        
        
    def is_right_triangle(self, a, b, c):
        # TODO
        return True
        
        
    def is_equilateral_triangle(self, a, b, c):
        # TODO
        return True
        

def main():
    root = Tk()
    app = MyApplication(root)
    root.mainloop()

main()
